package com.example.demo_fingerprint_fips.fragment;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;



import android.app.ProgressDialog;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.support.v4.app.Fragment;
import android.telephony.TelephonyManager;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RadioButton;
import android.widget.TextView;
import android.widget.Toast;

import com.example.demo_fingerprint_fips.FileUtils;
import com.example.demo_fingerprint_fips.MainActivity;
import com.example.demo_fingerprint_fips.R;
import com.rscja.deviceapi.FingerprintWithMorpho;
import com.rscja.utility.StringUtility;


import static android.content.Context.TELEPHONY_SERVICE;

public class AcquisitionFragment extends KeyDwonFragment implements  OnClickListener{

	private static int flag=101;
	private static final String TAG = "FingerprintWithMorpho";
	private MainActivity mContext;
    Button btnCapturet,btnEnroll,btnGetVersion,btSetTimeOut;
	Button btnCleanAll,btSetKey,btnGetID;
	TextView tvInfo, tv_plaintext;
	EditText etFirstName,etID,etKey,etTimeOut;
	CheckBox cbEncrypt;
	//Button btnGrab;
	ImageView iv;
	public final static String PATH = Environment
			.getExternalStorageDirectory()
			+ File.separator
			+ "fingerprint_fips"
			+ File.separator;
	String filePath = PATH + "finger.bmp";

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
							 Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.fingerprint_acquisition_fragment,
				container, false);
		return v;
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		mContext = (MainActivity) getActivity();
		init();
	}

	private void init() {
		Log.i(TAG, filePath);
		tv_plaintext = (TextView) getView().findViewById(R.id.tv_plaintext);
		etKey = (EditText) getView().findViewById(R.id.etKey);
		etTimeOut= (EditText) getView().findViewById(R.id.etTimeOut);

		btnCapturet = (Button) getView().findViewById(R.id.btnCapturet);
		btSetTimeOut = (Button) getView().findViewById(R.id.btSetTimeOut);
		btnGetVersion = (Button) getView().findViewById(R.id.btnGetVersion);
		tvInfo = (TextView) getView().findViewById(R.id.tvInfo);
		etFirstName=(EditText)getView().findViewById(R.id.etFirstName);
		etID=(EditText)getView().findViewById(R.id.etID);
		btnEnroll=(Button)getView().findViewById(R.id.btnEnroll);
		btnCleanAll=(Button)getView().findViewById(R.id.btnCleanAll);
		btSetKey=(Button)getView().findViewById(R.id.btSetKey);
		btnGetID=(Button)getView().findViewById(R.id.btnGetID);
		cbEncrypt=(CheckBox) getView().findViewById(R.id.cbEncrypt);
		btnGetID.setOnClickListener(this);
		btnCleanAll.setOnClickListener(this);
		btnCapturet.setOnClickListener(this);
		btnEnroll.setOnClickListener(this);
		btnGetVersion.setOnClickListener(this);
		btSetTimeOut.setOnClickListener(this);
		btSetKey.setOnClickListener(this);
		mContext.mFingerprint.setPtEnrollCallBack(new EnrollCallBack());
		mContext.mFingerprint.setPtCaptureCallBack(new PtCaptureCallBack());
	}


	@Override
	public void onPause() {
		super.onPause();
		Log.e(TAG,"-----------onPause----------------");
		tvInfo.setText("");
        stop();
	}

	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
	}

	@Override
	public void onClick(View view) {

		switch (view.getId()){
			case R.id.btnCapturet:
				start();
				tvInfo.setText("Processing, please keep finger on the sensor!");
				mContext.mFingerprint.startPtCapture(cbEncrypt.isChecked());//
				break;
			case R.id.btnEnroll:
				tvInfo.setText("Processing, please keep finger on the sensor!");
				String name=etFirstName.getText().toString();
				String id=etID.getText().toString();

				if(id.isEmpty()){
					Toast.makeText(mContext,"ID is not valid!",Toast.LENGTH_SHORT).show();
					return;
				}
				if(name.isEmpty()){
					Toast.makeText(mContext,"The name is empty!",Toast.LENGTH_SHORT).show();
					return;
				}
				InputMethodManager imm = (InputMethodManager) mContext.getSystemService(mContext.INPUT_METHOD_SERVICE);
				if (imm != null) {
					imm.hideSoftInputFromWindow(mContext.getWindow().getDecorView().getWindowToken(), 0);
				}
				start();
				mContext.mFingerprint.startEnroll(Integer.parseInt(id),name);
				break;
			case R.id.btnCleanAll:
				if(mContext.mFingerprint.morphoEraseAllBase()){
					Toast.makeText(mContext,"Success!",Toast.LENGTH_SHORT).show();
				}else{
					Toast.makeText(mContext,"fail!",Toast.LENGTH_SHORT).show();
				}
				break;
			case R.id.btnGetVersion:
				String version=mContext.mFingerprint.getMorphoDescriptor();
				tvInfo.setText("version:"+version);
				break;
			case R.id.btSetKey:
				String key=etKey.getText().toString();
				if(key!=null && key.length()>0){
					byte[] buffKey=key.getBytes();
                    if(mContext.mFingerprint.setMorphoLoadKs(buffKey)){
                     Toast.makeText(getActivity(),"success",Toast.LENGTH_SHORT).show();
				   }else{
						Toast.makeText(getActivity(),"fail",Toast.LENGTH_SHORT).show();
					}
				}
				break;
			case  R.id.btnGetID:
				String strID=mContext.mFingerprint.getMorphoPIDSN();
				tvInfo.setText("ID:"+strID);
				break;
			case R.id.btSetTimeOut:
				String time=etTimeOut.getText().toString();
				if(time==null || time.isEmpty()){
					Toast.makeText(getActivity(),"fail",Toast.LENGTH_SHORT).show();
					return;
				}

				if(mContext.mFingerprint.setTimeOut(Integer.parseInt(time.toString()))){
					Toast.makeText(getActivity(),"success",Toast.LENGTH_SHORT).show();
				}else{
					Toast.makeText(getActivity(),"fail",Toast.LENGTH_SHORT).show();
				}
				break;
		}
	}

	class  PtCaptureCallBack implements FingerprintWithMorpho.PtCaptureCallBack{
		@Override
		public void messageInfo(String s,int code) {
			tvInfo.setText(s+"\r\n"+tvInfo.getText());
			Log.e(TAG,"msg---->"+s);
			setMeg(s);
		}

		@Override
		public void onComplete(boolean b, byte[] bytes, int i) {
			stop();
			if(b) {
				if(bytes!=null) {
					tv_plaintext.setText(FileUtils.bytes2HexString2(bytes, bytes.length));
					FileUtils.WritFile2("data.bin", bytes);
				}
				mContext.playSound(1);
			}else{
				mContext.playSound(2);
			}

		}
	}
	class EnrollCallBack implements FingerprintWithMorpho.EnrollCallBack{
		@Override
		public void messageInfo(String s,int code) {
			tvInfo.setText(s);
			setMeg(s);
		}

		@Override
		public void onComplete(boolean b, int i) {
			stop();
			if(b) {
				mContext.playSound(1);
			}else{
				mContext.playSound(2);
			}
		}
	}

	void start(){
		showProgressDialog();
	}
	void stop(){
		if(mypDialog!=null)mypDialog.dismiss();
	}
	ProgressDialog mypDialog=null;
	public void showProgressDialog() {
		if(mypDialog==null) {
			mypDialog = new ProgressDialog(mContext);
		}
		mypDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		mypDialog.setMessage("wait...");
		mypDialog.setCancelable(false);
		mypDialog.setCanceledOnTouchOutside(false);
		mypDialog.show();
	}
	public  void setMeg(String msg){
		if(mypDialog!=null)
		mypDialog.setMessage(msg);
	}

}
